{   Cdrom. Used to check CDRom functions in unit SDL.

    Copyright (C) 2006 by Eike Lange (eike.lange@uni-essen.de)
    
    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, version 2.
    
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.
    
    You should have received a copy of the GNU General Public License
    along with this program; see the file COPYING. If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
    
    As a special exception, if you incorporate even large parts of the
    code of this demo program into another program with substantially
    different functionality, this does not cause the other program to
    be covered by the GNU General Public License. This exception does
    not however invalidate any other reasons why it might be covered
    by the GNU General Public License.
}

{ compile this program the usual way:
  gpc --automake cdrom.pas -o cdrom
}

program Cdrom;

uses Sdl, GPC;

var
  NumDrives, i: Integer;
  CdName: TString;
  TheCd: PSdlCd;
  Status: CDStatus;
begin
  if SdlInit (SdlInitCdrom) < 0 then
    begin
      WriteLn (StdErr, 'SdlInit failed: ', SdlGetError);
      Halt
    end;
  AtExit (SdlQuit);
  NumDrives := SdlCdNumDrives;
  WriteLn ('There are ', NumDrives, ' cdroms available ');
  if NumDrives > 0 then
    begin
      for i := 0 to NumDrives - 1 do
        begin
          CdName := SdlCdName (i);
          WriteLn ('  CD ', i, ' name is ', CdName)
        end;
      TheCd := SdlCdOpen (0);
      Status := SdlCdStatus (TheCd);
      WriteLn ('Status: ', Status);
      if CdInDrive (Status) then
        WriteLn ('Cd is in drive');
      if SdlCdEject (TheCd) then
        WriteLn ('Try to open CdRom');
      SdlCdClose (TheCd)
    end
end.
